import type { Inferno } from './types';
import { IComponent } from './types';
export declare function rerender(): void;
export declare type ComponentType<P = {}> = Component<P> | Inferno.StatelessComponent<P>;
export declare class Component<P = {}, S = {}> implements IComponent<P, S> {
    state: S | null;
    props: Readonly<{
        children?: Inferno.InfernoNode | undefined;
    }> & Readonly<P>;
    context: any;
    displayName?: string;
    $BR: boolean;
    $BS: boolean;
    $PS: Partial<S> | null;
    $LI: any;
    $UN: boolean;
    $CX: any;
    $QU: Function[] | null;
    $N: boolean;
    $SSR?: boolean;
    $L: Function[] | null;
    $SVG: boolean;
    $F: boolean;
    constructor(props?: P, context?: any);
    forceUpdate(callback?: Function): void;
    setState<K extends keyof S>(newState: ((prevState: Readonly<S>, props: Readonly<P>) => Pick<S, K> | S | null) | (Pick<S, K> | S | null), callback?: () => void): void;
    componentDidMount?(): void;
    componentWillMount?(): void;
    componentWillReceiveProps?(nextProps: {
        children?: Inferno.InfernoNode;
    } & P, nextContext: any): void;
    shouldComponentUpdate?(nextProps: {
        children?: Inferno.InfernoNode;
    } & P, nextState: Readonly<S>, context: any): boolean;
    componentWillUpdate?(nextProps: {
        children?: Inferno.InfernoNode;
    } & P, nextState: Readonly<S>, context: any): void;
    componentDidUpdate?(prevProps: {
        children?: Inferno.InfernoNode;
    } & P, prevState: Readonly<S>, snapshot: any): void;
    componentWillUnmount?(): void;
    getChildContext?(): void;
    getSnapshotBeforeUpdate?(prevProps: {
        children?: Inferno.InfernoNode;
    } & P, prevState: Readonly<S>): any;
    static defaultProps?: {};
    static getDerivedStateFromProps?(nextProps: any, state: any): any;
    render(_nextProps: {
        children?: Inferno.InfernoNode;
    } & P, _nextState: Readonly<S>, _nextContext: any): Inferno.InfernoNode;
}
